<template>
<div id="personalInfo" style="background-color:#F7F7F7;">
    <div class="personalInfo">
      <div class="personalInfo-title" >
        <img :src="back" @click="goback()"/>
      </div>
      <div class="clear"></div>
      <div class="personalInfo-data" @click="edit()">头像
        <img :src="editForm.avatar" v-if="!editInputVisible" />
        <div class="uploadAvatar" v-if="editInputVisible">
          <van-uploader
          v-model="fileList"
          preview-size="40px"
          :preview-full-image='false'
          :before-read="beforeFileUpload"
          :after-read="afterFileUpload"
          multiple
          :max-count="1">
          <img :src="editForm.avatar"/>
          </van-uploader>
        </div>
      </div>
      <div class="clear"></div>
      <div class="personalInfo-data" @click="onNickNameShow()">用户名
        <div class="editForm" >{{editForm.userName}}</div>
      </div>
      <div class="clear"></div>
      <div class="personalInfo-data" @click="onDescriptionShow()">描述
        <div class="editForm" >{{editForm.description}}</div>
      </div>
      <div class="clear"></div>
      <div class="personalInfo-data" @click="onPhoneNumberShow()">电话
        <div class="editForm" >{{editForm.phoneNumber}}</div>
      </div>
      <div class="clear"></div>
      <div class="personalInfo-data" @click="onShow()">性别
        <div class="editForm" >{{myGender}}</div>
      </div>
      <div class="clear"></div>
      <div class="personalInfo-data" @click="onAgeShow()">年龄
        <div class="editForm" >{{editForm.age}}</div>
      </div>
      <div class="clear"></div>
      <div class="personalInfo-data" @click="onSchoolShow()">所在学校
        <div class="editForm" >{{editForm.school}}</div>
      </div>
      <div class="clear"></div>
      <div class="personalInfo-data" @click="onExpShow()">学院 专业
        <div class="editForm" >{{editForm.Exp}}</div>
      </div>
      <div style="margin-bottom:20%;"></div>
      <div class="clear"></div>
    </div>
    <van-popup
            v-model="show"
            position="bottom"
            :style="{height: '40%'}"
            :overlay="true">
            <van-picker :columns="columns" :show-toolbar='true' title='请选择你的性别' @cancel="onCancel" @confirm="onConfirm" @change="onChange"/>
      </van-popup>
      <van-popup
            v-model="Ageshow"
            position="bottom"
            :style="{height: '40%'}"
            :overlay="true">
            <van-picker :columns="AgeColumns" :show-toolbar='true' title='请选择你的年龄' @cancel="onAgeCancel" @confirm="onAgeConfirm" @change="onAgeChange"/>
      </van-popup>
      <van-popup
            v-model="ExpShow"
            position="bottom"
            :style="{height: '40%'}"
            :overlay="true">
            <van-picker :columns="ExpColumns" :show-toolbar='true' @cancel="onExpCancel" @confirm="onExpConfirm" @change="onExpChange" />
      </van-popup>
      <van-number-keyboard
        v-model="editForm.phoneNumber"
        :show="phoneNumberShow"
        close-button-text="完成"
        :maxlength="11"
        @blur="phoneNumberShow=false"
      />
      <van-popup
            v-model="nickNameShow"
            position="bottom"
            :style="{height: '40%'}"
            :overlay="true">
            <van-nav-bar
                title="请输入用户名"
                left-text="返回"
                right-text="确认"
                
                @click-left="onClickLeft"
                @click-right="onClickLeft"
              />
            <div style="margin-left:15px;margin-right:15px;margin-top:15px">
            <el-input v-model="editForm.userName" size="small" clearable maxlength="30" show-word-limit placeholder="请输入用户名"></el-input>
            </div>
      </van-popup>
      <van-popup
            v-model="descriptionShow"
            position="bottom"
            :style="{height: '40%'}"
            :overlay="true">
           <van-nav-bar
                title="请简单介绍一下你自己"
                left-text="返回"
                right-text="确认"
                @click-left="onClickLeft2"
                @click-right="onClickLeft2"
              />
            <div style="margin-left:15px;margin-right:15px;margin-top:15px">
            <el-input v-model="editForm.description" size="small" clearable maxlength="30" show-word-limit placeholder="请简单介绍下你自己"></el-input>
            </div>
      </van-popup>
      <van-popup
            v-model="schoolShow"
            position="bottom"
            :style="{height: '40%'}"
            :overlay="true">
            <van-nav-bar
                title="请输入你所在的学校"
                left-text="返回"
                right-text="确认"
                @click-left="onClickLeft3"
                @click-right="onClickLeft3"
              />
            <div style="margin-left:15px;margin-right:15px;margin-top:15px">
            <el-input v-model="editForm.school" size="small" clearable maxlength="30" show-word-limit placeholder="请输入你所在的学校"></el-input>
            </div>
      </van-popup>
</div>
</template>

<script>
import back_png from '@/assets/goback.png'
import axios from 'axios'
const Exp={
  '软件学院':['软件工程'],
  '外国语':['英语','日语','德语','法语'],
  '商学院':['管理科学与工程','工商管理','会计学','经济学','金融学'],
  '法学院':['法律'],
  '理学院':['数学与应用数学','应用物理学','光电信息科学与工程'],
  '艺术设计与传媒':['艺术设计','工业设计','传媒'],
  '社会与公共管理':['公共管理','社会工作','行政管理','社会学'],
  '信息科学与工程':['自动化','电子与通信工程','计算机科学与工程'],
  '化学与分子工程':['化学工程与工艺','资源循环科学与工程'],
  '资源与环境工程':['能源化工','环境工程','给排水工程'],
  '体育学院':['体育教育','社会体育','民族传统体育'],
  '农学院':['农村区域发展','农学'],
  '医学院':['药学','临床医学','中西医临床医学','护理学','中医学','影像学']
};
export default {
  name: 'PersonInfo_toItself',
  data () {
    return {
      editForm: {
        avatar:'1',
        userName: '',
        phoneNumber: '11111111111',
        gender: 0,
        age: 20,
        school: '',
        college: '',
        major: '',
        otherExp:null,
        Exp:"",
        description: ''
      },
      myGender:"男",
      show:false,
      ExpShow:false,
      Ageshow:false,
      avatarShow:false,
      phoneNumberShow:false,
      descriptionShow:false,
      nickNameShow:false,
      schoolShow:false,
      back: back_png,
      editButtonVisible: true,
      saveButtonVisible: false,
      editInputVisible: false,
      fileList:[],
      columns:["男","女"],
      AgeColumns:['1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16',
      '17','18','19','20','21','22','23','24','25','26','27','28','29','30','31','32','33','34','35',
      '36','37','38','39','40','41','42','43','44','45','46','47','48','49','50','51','52','53','54',
      '55','56','57','58','59','60','61','62','63','64','65','66','67','68','69','70','71','72','73',
      '74','75','76','77','78','79','80','81','82','83','84','85','86','87','88','89','90','91','92',
      '93','94','95','96','97','98','99','100','101','102','103','104','105'],
      filename:"",
      ExpColumns:[
        {
          values:Object.keys(Exp),
          classname:'column1',
          defaultIndex:0
        },
        {
          values:Exp['软件学院'],
          classname:'column2',
          defaultIndex:0
        }
      ],
    }
  },
  methods: {
    onClickLeft(){
      this.nickNameShow=false
    },
    onClickLeft2(){
      this.descriptionShow=false
    },
    onClickLeft3(){
      this.schoolShow=false
    },
    onExpCancel(){
      this.ExpShow=false
    },
    onExpConfirm(){
      this.submit()
      this.ExpShow=false
    },
    onSchoolShow(){
      this.schoolShow=true
    },
    onPhoneNumberShow(){
      this.editForm.phoneNumber=""
      this.phoneNumberShow=true
    },
    onDescriptionShow(){
      this.descriptionShow=true
    },
    onNickNameShow(){
      this.nickNameShow=true
    },
    goback () {
      this.submit()
      this.$router.push('/Setting')
    },
    edit () {
      this.editInputVisible = true
    },
    onExpShow(){
      this.ExpShow=true
      this.editForm.college='软件学院'
       this.editForm.major=Exp['软件学院'][0]
       this.editForm.Exp=this.editForm.college+" "+this.editForm.major
    },
    onExpChange(picker,values,index){
      picker.setColumnValues(1, Exp[values[0]]);
      console.log(values[0])
       this.editForm.college=values[0]
       this.editForm.major=Exp[values[0]][index]
       this.editForm.Exp=this.editForm.college+" "+this.editForm.major
    },
    onPhoneNumber(){
      this.submit()
    },
    onAgeShow(){
      this.Ageshow=true;
    },
    onAgeChange(picker,value,index){
      this.editForm.age=value;
    },
    onAgeCancel(){
      this.Ageshow=false;
    },
    onAgeConfirm(){
      this.Ageshow=false;
    },
    onShow(){
      this.show=true;
    },
     onChange(picker, value,index) {
      this.myGender=value
    },
     onCancel(){
       this.show=false;
     },
     onConfirm(picker, value,index) {
       
      this.submit()
      this.show=false;
    },
    submit () {
      console.log()
      if(this.myGender=="男"){this.editForm.gender=1}
      if(this.myGender=="女"){this.editForm.gender=0}
      this.$api.putMyInfo(this.editForm.userName, this.editForm.avatar, this.editForm.gender, this.editForm.school, this.editForm.college, this.editForm.major, this.editForm.description, this.editForm.age, this.editForm.phoneNumber, this.editForm.otherExp)
        .then((res) => {
          this.editForm.Exp=this.editForm.college+" "+this.editForm.major
        }).catch((error) => {
          console.log(error)
        })
    },
    beforeFileUpload (file) {
      if (file.type !== 'image/jpeg') {
        this.$toast('请上传 jpg 格式图片')
        return false
      }

      return true
    },

    async afterFileUpload (file, detail) {
      this.file=file.file
      console.log(this.file)
      this.filename=await this.$api.uploadFile(this.file,"/folder1")
      console.log(this.filename)
      this.editForm.avatar=this.$api.getFileUrl(this.filename,"/folder1")
      console.log(this.editForm.avatar)
      this.submit()
    }
  },
  mounted:function(){
    this.$api.myInfo().then((res) => {
      this.editForm.avatar=res.data.data.profilePhotoUrl;
      console.log(res.data.data.profilePhotoUrl);
      this.editForm.userName = res.data.data.name;
      if(this.editForm.userName==null){this.editForm.userName="未设置"}
      this.editForm.gender = res.data.data.sexual;
      if(this.editForm.gender==0){this.myGender="女"}
      if(this.editForm.gender==1){this.myGender="男"}
      this.editForm.age=res.data.data.age;
      if(this.editForm.age==null){this.editForm.age=18}
      this.editForm.otherExp=res.data.data.education
      this.editForm.phoneNumber=res.data.data.phoneNumber
      if(this.editForm.phoneNumber==''){this.editForm.phoneNumber="请输入你的电话"}
      if(this.editForm.phoneNumber==null){this.editForm.phoneNumber="请输入你的电话"}
      this.editForm.college = res.data.data.college
      this.editForm.major = res.data.data.major
      this.editForm.description = res.data.data.introduction
      if(this.editForm.description==null){this.editForm.description="请输入你的描述"}
      this.editForm.Exp=this.editForm.college+" "+this.editForm.major
      this.editForm.school=res.data.data.university
      if(this.editForm.school==null){this.editForm.school="未设置"}
    })
  }
}
</script>

<style scoped lang="less">
#personalInfo{
  width:100%;
  height:100%;
  background-color:#F7F7F7;
  padding-bottom: 140px;
  .personalInfo-title{
    height:58px;
    width:100%;
    position: fixed;
    top:0px;
    left:0px;
    display: flex;
    letter-spacing: 0.113rem;
    line-height: 58px;
    flex-direction: column;
    font-size:30px;
    background-color:white;
    margin-bottom: 30px;
    //margin-top: 10px solid #ffffff;
  }
  .myPicker{
    margin-top:10px;
    height:20px;
  }
  .personalInfo-title img{
    height:18px;
    width:13px;
    padding-top:21px;
    padding-left:3%;
    z-index: -100;
  }
  .editButton{
    position:fixed;
    top:21px;
    right:5%;
    font-size:13px;
    height:20px;
    width:40px;
    font-weight:bold;
    color:white;
    text-align: center;
    background-color: #3170ff;
    //margin:2px 2.8% 2px 4px;
    line-height: 20px;
    border-radius:5px;
  }
  .uploadAvatar{
    float:right;
    color:#A5A5A5;
    position: relative;
    width:20px;
    height:20px;
    padding-right:4%;
    top:3px;
  }
  .personalInfo{
    height:100%;
    width:100%;
    padding-top:78px;
    background-color:#F7F7F7;
    display: flex;

    flex-direction: column;
    .personalInfo-data{
        font-size:13px;
        margin-top: 4px;
        height:43px;
        line-height:43px;
        letter-spacing: 0.113rem;
        //padding-top:17px;
        font-weight:bold;
        padding-left:5%;
        padding-right:5%;
        //padding-bottom: 13px;
        background-color:white;
        border-block-end: 3px ;
    }
    .personalInfo-data img{
        width:33px;
        height:33px;
        margin-top:5px;
        float:right;
        border-radius:100%;
    }
  }
  .clear{
        clear: both;
    }
  .editForm{
    float:right;
    color:#A5A5A5;
    position: relative;
    .editForm-input{
      position:absolute;
      top:10px;
      right:0px;
      border:0px;
      color:black;
      letter-spacing: 0.113rem;
      text-align: right;
      height:20px;
      width:200px;
    }
    .editForm-select{
      position:absolute;
      top:10px;
      right:0px;
      border:0px;
      color:black;
      letter-spacing: 0.113rem;
      text-align: right;
      height:20px;
      width:50px;
    }
  }
}
</style>
